import pygame, sys,os 
from pygame.locals import *
from pygame.color import THECOLORS
from Config import *
from Dart import *
import random
from run import *
from board import Board
import time
from top5 import *
#########################################################
def Draw(name,x,y):
	screen = pygame.display.get_surface()
	screen.blit(name, (x,y))	
############################################################
class Menu():
	def __init__(self):
		self.mode=1
		self.clock = pygame.time.Clock()
		self.status=0 #0=start,1=exit
	def update(self, fps):
		pygame.mixer.Sound(os.path.join('data/sound', 'arena1.ogg')).play()
		while self.mode==1:
			self.clock.tick(fps)
			#pygame.event.pump()
			events = pygame.event.get()
			for e in events:
				if (e.type == KEYDOWN):
					#if( e.key == K_ESCAPE ):
					#	pygame.mixer.Sound(os.path.join('data/sound', 'button.mp3')).play()
					#	self.run = False
					#	break
					if( e.key == K_UP ):
						self.status=0
						pygame.mixer.Sound(os.path.join('data/sound', 'button.mp3')).play()
					if( e.key == K_DOWN ):
						self.status=1
						pygame.mixer.Sound(os.path.join('data/sound', 'button.mp3')).play()
					if(self.status==0 and e.key == K_SPACE ):
						pygame.mixer.Sound(os.path.join('data/sound', 'button.mp3')).play()						
						self.mode=2
						break
					if(self.status==1 and e.key == K_SPACE ):
						pygame.mixer.Sound(os.path.join('data/sound', 'button.mp3')).play()
						self.mode=0
						break
			self.draw()
	def get_mode(self):
		return self.mode
	def reset_mode(self):
		self.mode=1
	def draw(self):
		Draw(MENU,0,0)
		if self.status==0:
			Draw(START_1,900,600)
			Draw(EXIT_2,900,700)		
		if self.status==1:
			Draw(START_2,900,600)
			Draw(EXIT_1,900,700)
		pygame.display.flip()
##################################################
class Load_Game():
	def __init__(self):
		self.end=100#100
		#print pygame.time.get_ticks()
	def run(self):
		i=0
		while(i<self.end):
			events = pygame.event.get()
			Draw(LOAD_GAME,0,0)
			pygame.display.flip()
			i+=1
###################################################
class Game():
	def __init__(self):
		self.end=False
		self.clock = pygame.time.Clock()
		self.status=0 #0=start,1=exit
		self.run=True
		self.num_dart=10
		self.score=0
		self.all_drt=[]
		self.wind=0
		self.shoot=False
		self.add=False
		self.switch=0
		self.force=1
		self.get_x=0
		self.cheet=False
		self.user=""
	def update(self, fps):	
		drt=DART()
		self.wind=random.randint(-5, 5) ##---wind	
		traget_y=0
		traget_x=0
		angle=45 ###--angle
		per_move=0
		start=0
		while self.run:
			events = pygame.event.get()
			for e in events:
				if (e.type == KEYDOWN):
					if( e.key == K_ESCAPE ):
						self.end=True
						self.run = False
						break
					#if( e.key == K_a ):
					#	drt.move(-10,0)
					#if( e.key == K_d ):
					#	drt.move(10,0)
					#if( e.key == K_w ):
					#	drt.move(0,-10)
					#if( e.key == K_s ):
					#	drt.move(0,10)
					if( e.key == K_o ):
						self.shoot=True
						traget_y=300
						traget_x=710
						x,y=drt.pos()
						start=y
						self.wind=0
			x,y=drt.pos()
			####shoot
			if(self.shoot):
				tm_y=drt.position_y
				per_move=100-int((y-traget_y)/(start-traget_y) *100)				
				if(0<=per_move<20):
					drt.set_status(1)
				elif(20<=per_move<40):
					drt.set_status(2)
				elif(40<=per_move<60):
					drt.set_status(3)
				elif(60<=per_move<80):
					drt.set_status(4)
				elif(80<=per_move<100):
					drt.set_status(5)					
				if(drt.position_y()>traget_y):
					drt.move(self.wind*5,-50+math.fabs(self.wind)*5)  ####--- move dart
				else:
					self.add=True
					self.shoot=False
			if(self.add):
				self.wind=random.randint(-5, 5)	
				self.num_dart-=1
				self.score+=drt.check()
				drt.set_status(6)
				self.all_drt.append(drt)
				drt=DART()
				self.add=False
				pygame.mixer.Sound(os.path.join('data/sound', 'sound.mp3')).play()
			####
			self.draw()
			for i in self.all_drt:
				i.draw()
			#########wind
			if self.wind==1:
				Draw(WRIGHT,50,767)
			elif self.wind==2:
				Draw(WRIGHT,50,767)
				Draw(WRIGHT,100,767)
			elif self.wind==3:
				Draw(WRIGHT,50,767)
				Draw(WRIGHT,100,767)
				Draw(WRIGHT,150,767)
			elif self.wind==4:
				Draw(WRIGHT,50,767)
				Draw(WRIGHT,100,767)
				Draw(WRIGHT,150,767)
				Draw(WRIGHT,200,767)
			elif self.wind==5:
				Draw(WRIGHT,50,767)
				Draw(WRIGHT,100,767)
				Draw(WRIGHT,150,767)
				Draw(WRIGHT,200,767)
				Draw(WRIGHT,250,767)
			elif self.wind==-1:
				Draw(WLEFT,250,767)
			elif self.wind==-2:
				Draw(WLEFT,250,767)
				Draw(WLEFT,200,767)
			elif self.wind==-3:
				Draw(WLEFT,250,767)
				Draw(WLEFT,200,767)
				Draw(WLEFT,150,767)
			elif self.wind==-4:
				Draw(WLEFT,250,767)
				Draw(WLEFT,200,767)
				Draw(WLEFT,150,767)
				Draw(WLEFT,100,767)
			elif self.wind==-5:
				Draw(WLEFT,250,767)
				Draw(WLEFT,200,767)
				Draw(WLEFT,150,767)
				Draw(WLEFT,100,767)
				Draw(WLEFT,50,767)			
			### pic
			for i in range(self.num_dart-1):
				Draw(DART_BF,1390-30*i,0)			
			###score
			sc = pygame.font.Font(None,120).render(str(self.score),False,(0,0,0))
			pygame.display.get_surface().blit(sc,(1200,775))
			###			
			drt.draw()
			### Game over
			if(self.num_dart==0):
				pygame.mixer.Sound(os.path.join('data/sound', 'arena1.ogg')).play()
				pygame.mixer.pause()
				self.Game_Over()
				self.Game_Score()
				self.end=True
				self.run = False
				break
			###
			pygame.display.flip()
			if(not(Board().get_switch()) and self.switch==0):
				if(not self.shoot):
					drt.setpos_x(read_cx()+200)
			if	Board().get_switch()and self.switch==0 :
				drt.setpos_x(read_cx()+200)
				self.switch=1
			if (not(Board().get_switch()) and self.switch==1):
				self.force=read_force()
				self.shoot=True
				traget_y=700 - (math.tan(angle*math.pi/180)*1000 - ((9.8*1000*1000)/(2*self.force*self.force*math.pow(math.cos(angle*math.pi/180),2)))) ##--traget
				x,y=drt.pos()
				start=y
				self.switch=0
				time.sleep(0.3)
			x,y=drt.pos()
			#print self.force
			#print self.force
			#print "mode ",self.switch
	def isend(self):
		return self.end
	def reset_game(self):
		self.all_drt=[]
		self.score=0
		self.num_dart=10
		self.user=""
		self.end=False
		self.run=True
	def draw(self):
		Draw(GAME_BACKGROUND,0,0)
	def Game_Over(self):
		chk=True
		pygame.mixer.Sound(os.path.join('data/sound', '70sgroove.wav')).play()
		while(chk):
			events = pygame.event.get()
			for e in events:
				if (e.type == KEYDOWN):
					if( e.key == K_SPACE ):
						chk=False						
						break
					if( e.key == K_a ):
						self.user+="a"
					elif( e.key == K_b ):
						self.user+="b"
					elif( e.key == K_c ):
						self.user+="c"
					elif( e.key == K_d ):
						self.user+="d"
					elif( e.key == K_e ):
						self.user+="e"
					elif( e.key == K_f ):
						self.user+="f"
					elif( e.key == K_g ):
						self.user+="g"
					elif( e.key == K_h ):
						self.user+="h"
					elif( e.key == K_i ):
						self.user+="i"
					elif( e.key == K_j ):
						self.user+="j"
					elif( e.key == K_k ):
						self.user+="k"
					elif( e.key == K_l ):
						self.user+="l"
					elif( e.key == K_m ):
						self.user+="m"
					elif( e.key == K_o ):
						self.user+="o"
					elif( e.key == K_n ):
						self.user+="n"
					elif( e.key == K_p ):
						self.user+="p"
					elif( e.key == K_q ):
						self.user+="q"
					elif( e.key == K_r ):
						self.user+="r"
					elif( e.key == K_s ):
						self.user+="s"
					elif( e.key == K_t ):
						self.user+="t"
					elif( e.key == K_u ):
						self.user+="u"
					elif( e.key == K_v ):
						self.user+="v"
					elif( e.key == K_w ):
						self.user+="w"
					elif( e.key == K_x ):
						self.user+="x"
					elif( e.key == K_y ):
						self.user+="y"
					elif( e.key == K_z ):
						self.user+="z"
					elif( e.key == K_1 ):
						self.user+="1"
					elif( e.key == K_2 ):
						self.user+="2"
					elif( e.key == K_3 ):
						self.user+="3"
					elif( e.key == K_4 ):
						self.user+="4"
					elif( e.key == K_5 ):
						self.user+="5"
					elif( e.key == K_6 ):
						self.user+="6"
					elif( e.key == K_7 ):
						self.user+="7"
					elif( e.key == K_8 ):
						self.user+="8"
					elif( e.key == K_9 ):
						self.user+="9"
					elif( e.key == K_0 ):
						self.user+="0"
					elif( e.key == K_BACKSPACE ):
						self.user=self.removelast(self.user)
			Draw(GAME_OVER,0,0)
			sc = pygame.font.Font(None,45).render(str(self.user),False,(0,0,0))
			pygame.display.get_surface().blit(sc,(925,587))
			sc = pygame.font.Font(None,300).render(str(self.score),False,(20,20,20))
			pygame.display.get_surface().blit(sc,(850,375))
			self.Grade()
			pygame.display.flip()
	def removelast(self,txt):
		tmp=""
		for i in range(len(txt)-1):
			tmp+=txt[i]
		return tmp
	def Game_Score(self):
		check=True
		py=350
		edit(str(self.user),str(self.score),self.Get_Grade(self.score))
		all_name=[]
		all_score=[]
		all_grade=[]
		for i in read_top():
			i=i.strip().split(' ')
			all_name.append(i[0])
			all_score.append(i[1])
			all_grade.append(i[2])
		while(check):
			events = pygame.event.get()
			for e in events:
				if (e.type == KEYDOWN):
					if( e.key == K_SPACE):
						check=False						
						break
			Draw(GAME_SCR,0,0)
			py=350
			for i in all_name:
				sc = pygame.font.Font(None,80).render(str(i),False,(0,0,0))
				pygame.display.get_surface().blit(sc,(150,py))
				py+=70
			py=350
			for i in all_score:
				sc = pygame.font.Font(None,80).render(str(i),False,(0,0,0))
				pygame.display.get_surface().blit(sc,(675,py))
				py+=70
			py=350
			for i in all_grade:
				sc = pygame.font.Font(None,80).render(str(i),False,(0,0,0))
				pygame.display.get_surface().blit(sc,(1175,py))
				py+=70
			pygame.display.flip()
	def Get_Grade(self,scr):
		if(85 <= scr <= 100 ):
			return "A"
		elif(80 <= scr < 85 ):
			return "B+"
		elif(75 <= scr < 80 ):
			return "B"
		elif(70 <= scr < 75 ):
			return "C+"
		elif(65 <= scr < 70 ):
			return "C"
		elif(60 <= scr < 65 ):
			return "D+"
		elif(55 <= scr < 60 ):
			return "D"
		elif(0 <= scr < 55 ):
			return "F"
	def Grade(self):
		if(85 <= self.score <= 100 ):
			sc = pygame.font.Font(None,300).render("A",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
		elif(80 <= self.score < 85 ):
			sc = pygame.font.Font(None,300).render("B+",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
		elif(75 <= self.score < 80 ):
			sc = pygame.font.Font(None,300).render("B",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
		elif(70 <= self.score < 75 ):
			sc = pygame.font.Font(None,300).render("C+",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
		elif(65 <= self.score < 70 ):
			sc = pygame.font.Font(None,300).render("C",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
		elif(60 <= self.score < 65 ):
			sc = pygame.font.Font(None,300).render("D+",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
		elif(55 <= self.score < 60 ):
			sc = pygame.font.Font(None,300).render("D",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
		elif(0 <= self.score < 55 ):
			sc = pygame.font.Font(None,300).render("F",False,(20,20,20))
			pygame.display.get_surface().blit(sc,(1100,700))
